--------------------------------------------------------------------------------------
-- Engine Script for controlling additional engines
-- RailWorks 2: Train Simulator
--------------------------------------------------------------------------------------

-- Boolean

-- Plow animation code
  SNOWEFFECTS01 = 8321 -- Britkits snow plows only
  SNOWEFFECTS02 = 8322 -- Britkits snow plows only
  LOWHEADLIGHT01 = 8323 -- Britkits headlights only
  LOWHEADLIGHT02 = 8324 -- Britkits headlights only

-- Plow animation code

	TRUE = 1
	FALSE = 0
	SnowStart = 3
	gLights = 0
	gLightsRev = 0


-- Plow animation code
  gMOWwings = 0
  gMOWnum = 0
  gPrevMOWwings = 0
  gMOWdir = 0
  gPrevMOWdir = 0
  gMOWcrew = 0
  gPrevMOWcrew = 0
  gMOWsnow = 0
-- Plow animation code

MAXTE = 0.8
ACCELRATE = 0.25

gSmokeColourR = 1.0
gSmokeColourG = 1.0
gSmokeColourB = 1.0
gEmitRate = 0.05


function Initialise ()

	gSmokeColourR, gSmokeColourG, gSmokeColourB = Call( "Exhaust01:GetEmitterColour" )

	-- turn off the lower light 
	Call( "headlight:ActivateNode", "lightglow",  0 );
	Call( "headlight2:ActivateNode", "lightglow",  0 );
	Call( "headlight3:ActivateNode", "lightglow",  0 );
	Call( "headlight4:ActivateNode", "lightglow",  0 );
	-- turn off the emergency light 
	Call( "headlight:ActivateNode", "lightglow_e",  0 );
	Call( "headlight2:ActivateNode", "lightglow_e",  0 );
	Call( "headlight3:ActivateNode", "lightglow_e",  0 );
	Call( "headlight4:ActivateNode", "lightglow_e",  0 );
	Call( "headlight5:ActivateNode", "lightglow_e",  0 );
	Call( "headlight6:ActivateNode", "lightglow_e",  0 );

	Call( "BeginUpdate" )

end

-- Passes any consist messages received along the train in the same direction.
function OnConsistMessage ( msg, argument, direction )

	if ( Call( "GetIsEngineWithKey" ) == FALSE ) then

		if ( msg == SNOWEFFECTS01 )   then 
          	gMOWsnow = 1
        end

        if ( msg == SNOWEFFECTS02 )   then 
			gMOWsnow = 0
        end
		
		if (msg == LOWHEADLIGHT01 ) then
			gLights = 1
		end
		
		if (msg == LOWHEADLIGHT02 ) then
			gLights = 0
		end
	
    end
	
	-- Pass message along in same direction.
	Call( "SendConsistMessage", msg, argument, direction )

end

function OnControlValueChange ( name, index, value )

	-- only set global values so we can do the real work in the Update function
	if Call( "*:ControlExists", name, index ) then
		
		if name == "Snow" then
			gMOWsnow = value
		end

		if name == "Headlights" then
			gLights = value
		end
          
		if name == "Reverser" then
			gMOWdir = value
		end

		Call( "*:SetControlValue", name, index, value );
	end
end

function Update ( time )

	
		TrainBrakeValve = Call( "*:GetControlValue", "TrainBrakeControl", 0 )
		if (TrainBrakeValve == 1) then
			Call( "headlight:ActivateNode", "lightglow_e",  1 )
			Call( "headlight2:ActivateNode", "lightglow_e",  1 )
			Call( "headlight3:ActivateNode", "lightglow_e",  1 )
			Call( "headlight4:ActivateNode", "lightglow_e",  1 )
			Call( "headlight5:ActivateNode", "lightglow_e",  1 )
			Call( "headlight6:ActivateNode", "lightglow_e",  1 )
		else
			Call( "headlight:ActivateNode", "lightglow_e",  0 )
			Call( "headlight2:ActivateNode", "lightglow_e",  0 )
			Call( "headlight3:ActivateNode", "lightglow_e",  0 )
			Call( "headlight4:ActivateNode", "lightglow_e",  0 )
			Call( "headlight5:ActivateNode", "lightglow_e",  0 )
			Call( "headlight6:ActivateNode", "lightglow_e",  0 )
		end
	
		
	-- here is where we will do all the real work
	--   don't forget to pass the message on to the consist
	--   passing a value of 0 sends the message to the front of the consist
	--   passing a value of 1 sends the message to the rear of the consist
	--   just remember that some rolling stock will use its orientaion 
	--   to figure out which direction the front is.

	-- lower light control
	if gLights == 1 then     -- foward
		Call( "headlight:ActivateNode", "lightglow",  1 )
		Call( "headlight2:ActivateNode", "lightglow",  0 )
		Call( "headlight3:ActivateNode", "lightglow",  1 )
		Call( "headlight4:ActivateNode", "lightglow",  0 )
		Call( "SendConsistMessage", LOWHEADLIGHT01, gLights, 0 )
		Call( "SendConsistMessage", LOWHEADLIGHT02, gLights, 1 )
	elseif gLights == 2 then -- rear
		Call( "headlight:ActivateNode", "lightglow",  0 )
		Call( "headlight2:ActivateNode", "lightglow",  1)
		Call( "headlight3:ActivateNode", "lightglow",  0 )
		Call( "headlight4:ActivateNode", "lightglow",  1)
		Call( "SendConsistMessage", LOWHEADLIGHT01, gLights, 1 )
		Call( "SendConsistMessage", LOWHEADLIGHT02, gLights, 0 )
	else                     -- off
		Call( "headlight:ActivateNode", "lightglow",  0 )
		Call( "headlight2:ActivateNode", "lightglow",  0 )
		Call( "headlight3:ActivateNode", "lightglow",  0 )
		Call( "headlight4:ActivateNode", "lightglow",  0 )
		Call( "SendConsistMessage", LOWHEADLIGHT01, gLights, 0 )
		Call( "SendConsistMessage", LOWHEADLIGHT01, gLights, 1 )
		Call( "SendConsistMessage", LOWHEADLIGHT02, gLights, 0 )
		Call( "SendConsistMessage", LOWHEADLIGHT02, gLights, 1 )
	end

	--Snow effects
    if gMOWsnow ==  1 then
		Call( "SendConsistMessage", SNOWEFFECTS01, gMOWsnow, 1 )
		Call( "SendConsistMessage", SNOWEFFECTS01, gMOWsnow, 0 )
    end   

    if gMOWsnow ==  0 then
		Call( "SendConsistMessage", SNOWEFFECTS02, gMOWsnow, 1 )
		Call( "SendConsistMessage", SNOWEFFECTS02, gMOWsnow, 0 )
    end   

	speed = Call( "GetSpeed" )
	if speed < 0.0 then 
		speed = -speed;
  	end

	if speed >= SnowStart and gMOWdir == 1 then
		Call( "Snow Spray Left:SetEmitterActive", 1 )
		Call( "Snow Chunks Left:SetEmitterActive", 1 )
		Call( "Snow Chunks Left2:SetEmitterActive", 1 )
		Call( "Snow Spray Right:SetEmitterActive", 1 )
		Call( "Snow Chunks Right:SetEmitterActive", 1 )
		Call( "Snow Chunks Right2:SetEmitterActive", 1 );
  	elseif speed >= SnowStart and gMOWdir == -1 then
		Call( "Snow Spray Left R:SetEmitterActive", 1 )
		Call( "Snow Chunks Left R:SetEmitterActive", 1 )
		Call( "Snow Chunks Left2 R:SetEmitterActive", 1 )
		Call( "Snow Spray Right R:SetEmitterActive", 1 )
		Call( "Snow Chunks Right R:SetEmitterActive", 1 )
		Call( "Snow Chunks Right2 R:SetEmitterActive", 1 );
  	else
		Call( "Snow Spray Left:SetEmitterActive",0 )
		Call( "Snow Chunks Left:SetEmitterActive", 0 )
		Call( "Snow Chunks Left2:SetEmitterActive", 0 )
		Call( "Snow Spray Right:SetEmitterActive", 0 )
		Call( "Snow Chunks Right:SetEmitterActive", 0 )
		Call( "Snow Chunks Right2:SetEmitterActive", 0 );
		Call( "Snow Spray Left R:SetEmitterActive",0 )
		Call( "Snow Chunks Left R:SetEmitterActive", 0 )
		Call( "Snow Chunks Left2 R:SetEmitterActive", 0 )
		Call( "Snow Spray Right R:SetEmitterActive", 0 )
		Call( "Snow Chunks Right R:SetEmitterActive", 0 )
		Call( "Snow Chunks Right2 R:SetEmitterActive", 0 );
    end
    

   if gMOWsnow == 1  then
	   Call ( "Snow:ActivateNode", "snow", 0 )
	   Call ( "Pilot:ActivateNode", "snow", 0 );
   else  
	   Call ( "Snow:ActivateNode", "snow", 1 )
	   Call ( "Pilot:ActivateNode", "snow", 1 );
   end  


	-- Control smoke	
	TractiveEffort = Call ( "GetTractiveEffort" )
	if TractiveEffort < 0.0 then 
		TractiveEffort = -TractiveEffort;			
	end
	
	if TractiveEffort < 0.1 then						
		gSmokeColourR = 0.8
		gSmokeColourG = 0.8
		gSmokeColourB = 0.8
		Call ( "Exhaust01:SetEmitterColour", gSmokeColourR, gSmokeColourG, gSmokeColourB )
		Call ( "Exhaust02:SetEmitterColour", gSmokeColourR, gSmokeColourG, gSmokeColourB )
		Call ( "Exhaust01:SetEmitterRate", gEmitRate )
		Call ( "Exhaust02:SetEmitterRate", gEmitRate )
	end
				
	if TractiveEffort <= 0.5 then	
		if TractiveEffort > 0.1 then					
		gSmokeColourR = 0.25
		gSmokeColourG = 0.25
		gSmokeColourB = 0.25
		Call ( "Exhaust01:SetEmitterColour", gSmokeColourR, gSmokeColourG, gSmokeColourB )
		Call ( "Exhaust02:SetEmitterColour", gSmokeColourR, gSmokeColourG, gSmokeColourB )
		Call ( "Exhaust01:SetEmitterRate", 0.01 )
		Call ( "Exhaust02:SetEmitterRate", 0.01 )
		end
	end
		
	if TractiveEffort > 0.51 then 
		gSmokeColourR = 0.0
		gSmokeColourG = 0.0
		gSmokeColourB = 0.0
		Call ( "Exhaust01:SetEmitterColour", gSmokeColourR, gSmokeColourG, gSmokeColourB )
		Call ( "Exhaust02:SetEmitterColour", gSmokeColourR, gSmokeColourG, gSmokeColourB )
		Call ( "Exhaust01:SetEmitterRate", 0.005 )
		Call ( "Exhaust02:SetEmitterRate", 0.005 )
	end
end

-- Track messages.
-- Handles detector messages.

function OnCustomSignalMessage ( Parameter )

	if ( Call( "GetIsPlayer" ) == TRUE ) and ( Call ("GetIsEngineWithKey") == TRUE ) then
		Detect = string.sub ( Parameter, 14, 15 )

		if Detect == "1" then
			Detect1 = Call( "*:GetControlValue", "TrackDetect1", 0 )
			Call( "*:SetControlValue", "TrackDetect1", 0, Detect1 + 1 )
		elseif Detect == "2" then
			Detect2 = Call( "*:GetControlValue", "TrackDetect2", 0 )
			Call( "*:SetControlValue", "TrackDetect2", 0, Detect2 + 1 )
		end
	end
end

